LIBRARY ReeSaver;

USES WinTypes, WinProcs, Strings, AfterDark;

TYPE
  TReeSaver = OBJECT(TAfterDark)
    NoOfColors: INTEGER;
    FUNCTION DoDrawFrame: INTEGER; VIRTUAL;
    FUNCTION DoButtonMessage2(Value: INTEGER): INTEGER; VIRTUAL;
    FUNCTION DoButtonMessage4(Value: INTEGER): INTEGER; VIRTUAL;
  END;

FUNCTION TReeSaver.DoDrawFrame: INTEGER;
VAR
  x,y: INTEGER;
  color: TColorRef;
BEGIN
  x := Random(lpModule^.ptRgnSize.x);
  y := Random(lpModule^.ptRgnSize.y);
  CASE NoOfColors OF
    1: color := RGB(0,0,0);
    2: IF ODD(Random(255)) THEN color := RGB(0,0,0) ELSE color := RGB(255,255,255);
    3: BEGIN
         CASE TRUNC(Random(5)) OF
           0: color := RGB(0,0,0);
           1: color := RGB(255,0,0);
           2: color := RGB(0,255,0);
           3: color := RGB(0,0,255);
           4: color := RGB(255,255,255);
         END;
       END;
    4: color := RGB(Random(255), Random(255), Random(255));
  END;
  SetPixel (DC, x, y, color);
  SetPixel (DC, x+1, y, color);
  SetPixel (DC, x, y+1, color);
  SetPixel (DC, x+1, y+1, color);
END;

FUNCTION TReeSaver.DoButtonMessage2 (Value: INTEGER): INTEGER;
BEGIN
  NoOfColors := (Value DIV 25)+1;
  DoButtonMessage2 := NoError;
END;

FUNCTION TReeSaver.DoButtonMessage4 (Value: INTEGER): INTEGER;
BEGIN
  (*MessageBox (, 'Mitteilung', 'MessageBox, mb_Yes);*)
  MessageBeep(0);
  DoButtonMessage4 := NoError;
END;

EXPORTS Module;

VAR
  MySaver: TReeSaver;

BEGIN
  Randomize;
  MySaver.Init;
END.