ausdruck(e,n,m,[x,y]) :- formel(e,n,m,[x,y]).

formel(e,n_,m,[x,y]) :- formel_(twice,p,n,m,[x,z]), rest-formel(p,e,n_,n,[z,y]).

formel_(w,p,n_,m,[x,y]) :- primary(f,n,m,[x,z]), rest-formel_(w,f,p,n_,n,[z,y]).

primary(p,n,m,[x,y]) :-
   wort('that',[x,u]),
   formel_(twice,p,n,m,[u,y]).
primary([o-a,p,q],n,m,[x,y]) :-
   wort(o,[x,z]),
   conc-junktor(o,o_,o-a),
   primary(p,m_,m,[z,u]),
   wort(o_,[u,v]),
   primary(q,n,m_,[v,y]).
primary(q,n,m,[x,y]) :-
   wort(p,[x,z]),
   diff-oder-gleich([p_,p],m,m_),
   relativs(p_,q_,n_,m_,[z,u]),
   conc-primary(q_,q,n,n_,[u,y]).

relativs(p,[o-a,p,p_],n,m,[x,y]) :-
   wort('who',[x,z]),
   wort(o,[z,u]),
   verb-junktor(o,o-a),
   primary(p_,n,m,[u,y]).
relativs(p,q,n,m,[x,y]) :-
   wort('who',[x,z]),
   rest-formel_(twice,p,q,n,m,[z,y]).
relativs(p,p,n,n,[x,x]).

conc-primary(p,[and,p,p_],n,m,[x,y]) :-
   wort(',',[x,z]),
   primary(p_,n,m,[z,y]).
conc-primary(p,[o-a,p,p_],n,m,[x,y]) :-
   wort(o,[x,z]),
   conc-junktor(o,o-a),
   primary(p_,n,m,[z,y]).
conc-primary(p,p,n,n,[x,x]).

rest-formel_(w,p,[o-a,p,[o-a_,q1,p]],n,m,[x,y]) :-
   wort(v-erb,[x,z]),
   verb-junktor(v-erb,o-a),
   wort(v-erb_,[z,u]),
   verb-junktor(v-erb_,o-a_),
   wort('by',[u,v]),
   formel_(once,q1,n,m,[v,y]).
rest-formel_(w,p,[o-a,p,q1,[o-a_,q1,q2]],n,m,[x,y]) :-
   wort(v-erb,[x,k]),
   verb-junktor(v-erb,o-a),
   formel_(once,q1,n_,m,[k,u]),
   wort(t-o,[u,z]),
   wort(o,[z,r]),
   verb-junktor(t-o,o,o-a_),
   formel_(once,q2,n,n_,[r,y]).
rest-formel_(w,p,[o-a,p,[o-a_,p,q2]],n,m,[x,y]) :-
   wort(v-erb,[x,u]),
   verb-junktor(v-erb,o-a),
   wort(t-o,[u,z]),
   wort(o,[z,r]),
   verb-junktor(t-o,o,o-a_),
   formel_(once,q2,n,m,[r,y]).
rest-formel_(w,p,q,n,m,[x,y]) :-
   hv-junktor(o-a,p,p_,q,[x,z]),
   wort(o,[z,u]),
   verb-junktor(o,o-a),
   formel_(once,p_,n,m,[u,y]).
rest-formel_(twice,p,[o-a,p,p_],n,m,[x,y]) :-
   wort(o,[x,z]),
   verb-junktor(o,o-a),
   formel_(once,p_,n,m,[z,y]).
rest-formel_(w,e,e,m,m,[x,x]).

hv-junktor(o-a__,p,p_,[o-a_ ; o-a,[o-a__,p,p_]],[x,y]) :-
   wort(o_,[x,z]),
   hilfs-junktor(o_,o-a_),
   wort(o,[z,y]),
   negation-junktor(o,o-a).
hv-junktor(o-a_,p,p_,[o-a,[o-a_,p,p_]],[x,y]) :-
   wort(o,[x,y]),
   hilfs-junktor(o,o-a).

rest-formel(p,[o-a,p,p_],n,m,[x,y]) :-
   wort(o,[x,z]),
   verb-junktor(o,o-a),
   formel(p_,n,m,[z,y]).
rest-formel(e,e,m,m,[x,x]).

wort(a,[a;x,x]).

diff-oder-gleich([k,n],nil,[k,n];nil).
diff-oder-gleich([k,n],[k,m];q,[k,m];q) :- eq(n,m).
diff-oder-gleich([k,n],[k_,m];q,[k_,m];p) :-
   dif(n,m),
   diff-oder-gleich([k,n],q,p).

lesen(nil) :- next-char_('.') / in-char_('.').
lesen(a;b) :- in-word(a,x) / lesen(b).
lesen(a;b) :- in-char_(a), lesen(b).

terminologie :-
   line,
   write('Namen:              Eigennamen'),
   write('Sprachjunktoren:    Verben').

grammatik :-
   terminologie,
   repeat,
   line,
   write('Ausdruck:   '),
   lesen(p),
   analysiere(p,e),
   write('Semantik:   '),
   outl(e),
   fail.

/* repeat. */
/* repeat :- repeat. */

analysiere(p,e) :- ausdruck(e,n,nil,[p,nil]) .
analysiere(p,e) :- write('            ...  ist nicht wohlgeformt'), fail.

/***********   DATENBANK  (Junktoren)   ***********/

verb-junktor('believes',believe).
verb-junktor('wants',want).
verb-junktor('asks',ask).
verb-junktor('knows',know).
verb-junktor('loves',love).
verb-junktor('finds',find).
verb-junktor('sees',see).
verb-junktor('believe',believe).
verb-junktor('want',want) .
verb-junktor('ask',ask) .
verb-junktor('know',know) .
verb-junktor('love',love) .
verb-junktor('find',find) .
verb-junktor('see',see) .
verb-junktor('to','believe',to-believe) .
verb-junktor('to','want',to-want) .
verb-junktor('to','ask',to-ask) .
verb-junktor('to','know',to-know) .
verb-junktor('to','love',to-love) .
verb-junktor('to','find',to-find) .
verb-junktor('to','see',to-see) .
verb-junktor('is',be-passive) .
verb-junktor('are',be-passive) .
verb-junktor('was',be-passive) .
verb-junktor('were',be-passive) .
verb-junktor('believed',believe) .
verb-junktor('wanted',want) .
verb-junktor('asked',ask) .
verb-junktor('knew',know) .
verb-junktor('known',know) .
verb-junktor('loved',love) .
verb-junktor('found',find) .
verb-junktor('saw',see) .
verb-junktor('seen',see) .

hilfs-junktor('do',do) .
hilfs-junktor('does',do) .
hilfs-junktor('did',do) .
hilfs-junktor('can',can) .
hilfs-junktor('could',can) .
hilfs-junktor('shall',shall) .
hilfs-junktor('should',shall) .
hilfs-junktor('will',will) .
hilfs-junktor('would',will) .
hilfs-junktor('may',may) .
hilfs-junktor('might',may) .

negation-junktor('not',not) .

conc-junktor('and',and) .
conc-junktor('or',or) .
conc-junktor('neither','nor',neither-nor) .
conc-junktor('either','or',either-or) .

/* .End world: Normal */

