
ausdruck(e,n,m,[x,y]) :- formel(e,n,m,[x,y]).

formel(e,n_,m,[x,y]) :- formel_(twice,p,n,m,[x,z]),
                        rest-formel(p,e,n_,n,[z,y]).

formel_(w,p,n_,m,[x,y]) :- primary(f,n,m,[x,z]),
                           rest-formel_(w,f,p,n_,n,[z,y]).

primary(p,n,m,[x,y]) :-
   wort('that',[x,u]),
   formel_(twice,p,n,m,[u,y]).
primary([o-a,p,q],n,m,[x,y]) :-
   wort(o,[x,z]),
   conc-junktor(o,o_,o-a),
   primary(p,m_,m,[z,u]),
   wort(o_,[u,v]),
   primary(q,n,m_,[v,y]).
primary(q,n,m,[x,y]) :-
   np(p_,m_,m,[x,z]),
   relativs(p_,q_,n_,m_,[z,u]),
   conc-primary(q_,q,n,n_,[u,y]).

np(o-a__,n,m,[x,y]) :-
   praep(o-a,o-a__,[x,x1]),
   wort(o,[x1,z]),
   quantor(p_,[o-a_,q,t],o,o-a),
   wort(p,[z,u]),
   diff-oder-gleich([p_,p,q],m,n_),
   wort(o_,[u,v]),
   conc-junktor(o_,o-a_),
   wort(b,[v,y]),
   diff-oder-gleich([b_,b,t],n_,n).
np(o-a_,n,m,[x,y]) :-
   praep(o-a,o-a_,[x,x1]),
   wort(o,[x1,z]),
   quantor(p_,q,o,o-a),
   wort(p,[z,y]),
   diff-oder-gleich([p_,p,q],m,n).
np(o-a_,n,m,[x,y]) :-
   praep(o-a,o-a_,[x,x1]),
   quantor(p_,q,EN,o-a),
   wort(p,[x1,y]),
   diff-oder-gleich([p_,p,q],m,n).

praep(o-a,o-a_,[x,x1]) :-
   wort(a,[x,x1]),
   praeposition(o-a,a,o-a_).
praep(o-a,o-a,[x,x]) .


relativs(p,o-a,n,m,[x,y]) :-
   wort('who',[x,z]),
   wort(o,[z,u]),
   verb-junktor(p,p_,o,o-a),
   primary(p_,n,m,[u,y]).
relativs(p,q,n,m,[x,y]) :-
   wort('who',[x,z]),
   rest-formel_(twice,p,q,n,m,[z,y]).
relativs(p,p,n,n,[x,x]) .

conc-primary(p,[and,p,p_],n,m,[x,y]) :-
   wort(',',[x,z]),
   primary(p_,n,m,[z,y]).
conc-primary(p,[o-a,p,p_],n,m,[x,y]) :-
   wort(o,[x,z]),
   conc-junktor(o,o-a),
   primary(p_,n,m,[z,y]).
conc-primary(p,p,n,n,[x,x]) .

rest-formel_(w,p,o-a,n,m,[x,y]) :-
   wort(v-erb,[x,z]),
   verb-junktor(p,o-a_,v-erb,o-a),
   wort(v-erb_,[z,u]),
   verb-junktor(q1,p,v-erb_,o-a_),
   wort('by',[u,v]),
   formel_(once,q1,n,m,[v,y]).
rest-formel_(w,p,o-a,n,m,[x,y]) :-
   wort(v-erb,[x,k]),
   verb-junktor(p,q1,o-a_,v-erb,o-a),
   formel_(once,q1,n_,m,[k,u]),
   wort(t-o,[u,z]),
   wort(o,[z,r]),
   verb-junktor(q1,q2,t-o,o,o-a_),
   formel_(once,q2,n,n_,[r,y]).
rest-formel_(w,p,o-a,n,m,[x,y]) :-
   wort(v-erb,[x,u]),
   verb-junktor(p,o-a_,v-erb,o-a),
   wort(t-o,[u,z]),
   wort(o,[z,r]),
   verb-junktor(p,q2,t-o,o,o-a_),
   formel_(once,q2,n,m,[r,y]).
rest-formel_(w,p,o-a,n,m,[x,y]) :-
   wort(v-erb,[x,u]),
   verb-junktor(p,q,q2,v-erb,o-a),
   formel_(once,q,n_,m,[u,z]),
   formel_(once,q2,n,n_,[z,y]).
rest-formel_(w,p,q,n,m,[x,y]) :-
   hv-junktor(o-a,q,[x,z]),
   wort(o,[z,u]),
   verb-junktor(p,p_,o,o-a),
   formel_(once,p_,n,m,[u,y]).
rest-formel_(twice,p,o-a,n,m,[x,y]) :-
   wort(o,[x,z]),
   verb-junktor(p,p_,o,o-a),
   formel_(once,p_,n,m,[z,y]).
rest-formel_(w,e,e,m,m,[x,x]) .

hv-junktor(o-a__,[o-a_;o-a,o-a__],[x,y]) :-
   wort(o_,[x,z]),
   hilfs-junktor(o_,o-a_),
   wort(o,[z,y]),
   negation-junktor(o,o-a).
hv-junktor(o-a_,[o-a,o-a_],[x,y]) :-
   wort(o,[x,y]),
   hilfs-junktor(o,o-a).

rest-formel(p,[o-a,p,p_],n,m,[x,y]) :-
   wort(o,[x,z]),
   verb-junktor(o,o-a),
   formel(p_,n,m,[z,y]).
rest-formel(e,e,m,m,[x,x]) .

wort(a,[a;x,x]) .

diff-oder-gleich([k,n,m],nil,[k,n,m];nil) :-
   individuen(k,n,m).
diff-oder-gleich([k,n,m_],[k,m,m_];q,[k,m,m_];q) :-
   eq(n,m),
   individuen(k,n,m_).
diff-oder-gleich([k,n,n_],[k_,m,m_];q,[k_,m,m_];p) :-
   dif(n,m),
   diff-oder-gleich([k,n,n_],q,p).

individuen(k,n,m) :- eigenname(k,n,m).
individuen(k,n,m) :- individuum(k,n,m).

lesen(nil) :- next-char_('.') / in-char_('.').
lesen(a;b) :- in-word(a,x) / lesen(b).
lesen(a;b) :- in-char_(a), lesen(b).

terminologie :-
   line,
   write('Namen:              Eigennamen'),
   write('Sprachjunktoren:    Verben').

grammatik :-
   terminologie,
   repeat,
   line,
   write('Ausdruck:   '),
   lesen(p),
   analysiere(p,e),
   write('Semantik:   '),
   outl(e),
   fail.

/* repeat . */
/* repeat :- repeat. */

analysiere(p,e) :- ausdruck(e,n,nil,[p,nil]) .
analysiere(p,e) :- write('            ...  ist nicht wohlgeformt'), fail.

/********************   DATENBANK  (Junktoren)   ********************/

verb-junktor(x,y,'believe',believe(x,y)) .
verb-junktor(x,y,'believes',believe(x,y)) .
verb-junktor(x,y,'believed',believe(x,y)) .
verb-junktor(x,y,'want',want(x,y)) .
verb-junktor(x,y,'wants',want(x,y)) .
verb-junktor(x,y,'wanted',want(x,y)) .
verb-junktor(x,y,'love',love(x,y)) .
verb-junktor(x,y,'loves',love(x,y)) .
verb-junktor(x,y,'loved',love(x,y)) .
verb-junktor(x,y,'like',like(x,y)) .
verb-junktor(x,y,'likes',like(x,y)) .
verb-junktor(x,y,'liked',like(x,y)) .
verb-junktor(x,y,'know',know(x,y)) .
verb-junktor(x,y,'knows',know(x,y)) .
verb-junktor(x,y,'knew',know(x,y)) .
verb-junktor(x,y,'find',find(x,y)) .
verb-junktor(x,y,'finds',find(x,y)) .
verb-junktor(x,y,'found',find(x,y)) .
verb-junktor(x,y,'see',see(x,y)) .
verb-junktor(x,y,'sees',see(x,y)) .
verb-junktor(x,y,'saw',see(x,y)) .
verb-junktor(x,y,z,'ask',ask(x,y,z)) .
verb-junktor(x,y,z,'asks',ask(x,y,z)) .
verb-junktor(x,y,z,'asked',ask(x,y,z)) .
verb-junktor(x,y,'to','believe',to-believe(x,y)) .
verb-junktor(x,y,'to','want',to-want(x,y)) .
verb-junktor(x,y,'to','ask',to-ask(x,y)) .
verb-junktor(x,y,'to','know',to-know(x,y)) .
verb-junktor(x,y,'to','love',to-love(x,y)) .
verb-junktor(x,y,'to','find',to-find(x,y)) .
verb-junktor(x,y,'to','see',to-see(x,y)) .
verb-junktor(x,y,'is',be-passive(x,y)) .
verb-junktor(x,y,'are',be-passive(x,y)) .
verb-junktor(x,y,'was',be-passive(x,y)) .
verb-junktor(x,y,'were',be-passive(x,y)) .
verb-junktor(x,y,z,'give',give(x,y,z)) .
verb-junktor(x,y,z,'gives',give(x,y,z)) .
verb-junktor(x,y,z,'gave',give(x,y,z)) .

hilfs-junktor('do',do) .
hilfs-junktor('does',do) .
hilfs-junktor('did',do) .
hilfs-junktor('can',can) .
hilfs-junktor('could',can) .
hilfs-junktor('shall',shall) .
hilfs-junktor('should',shall) .
hilfs-junktor('will',will) .
hilfs-junktor('would',will) .
hilfs-junktor('may',may) .
hilfs-junktor('might',may) .

negation-junktor('not',not) .

conc-junktor('and',and) .
conc-junktor('or',or) .
conc-junktor('neither','nor',neither-nor) .
conc-junktor('either','or',either-or) .

quantor(x,y,EN,exi(x,y)) .
quantor(x,y,'all',all(x,y)) .
quantor(x,y,'a',exi(x,y)) .
quantor(x,y,'no',non-exi(x,y)) .
quantor(x,y,'the',the(x,y)) .
quantor(x,y,'some',exi(x,y)) .
quantor(x,y,'every',all(x,y)) .
quantor(x,y,'each',all(x,y)) .
quantor(x,y,'few',few(x,y)) .
quantor(x,y,'most',most(x,y)) .

praeposition(o-a,'to',[to,o-a]) .
praeposition(o-a,'with',[with,o-a]) .
praeposition(o-a,'by',[by,o-a]) .

eigenname(x,'John',john(x)) .
eigenname(x,'Paul',paul(x)) .
eigenname(x,'Mary',mary(x)) .
eigenname(x,'Sue',sue(x)) .
eigenname(x,'Cindy',cindy(x)) .

individuum(x,'man',man(x)) .
individuum(x,'men',man(x)) .
individuum(x,'woman',woman(x)) .
individuum(x,'women',woman(x)) .
individuum(x,'people',people(x)) .
individuum(x,'boy',boy(x)) .
individuum(x,'boys',boy(x)) .
individuum(x,'girl',girl(x)) .
individuum(x,'girls',girl(x)) .


